%{
/*
       Jacek Pospychala jacekp@siat.pl grupa:poniedzialki, 15:10  
*/
#include "y.tab.h"
#include <string.h>
int yywrap(void);
int yylex(void);
int lineno=0;
%}
%x string
%%
void                   { yylval.inum=VOID; return VOID; }
int                    { yylval.inum=INT; return INT; }
char                   { yylval.inum=CHAR; return CHAR; }
long                   { yylval.inum=LONG; return LONG; }
static                 { yylval.inum=STATIC; return STATIC; }
const                  { yylval.inum=CONST; return CONST; }
register               { yylval.inum=REGISTER; return REGISTER; }
if                     { return IF; }
else                   { return ELSE; }
#print                 { return DIR_PRINT; }
return                 { return RETURN; }
[a-zA-Z_][a-zA-Z_0-9]* { yylval.text = strdup(yytext); return ID; }
[0-9]+                 { yylval.inum = atoi(yytext); return NUM; }
\;                     { return ';'; }
\,                     { return ','; }
\)                     { return ')'; }
\(                     { return '('; }
\}                     { return '}'; }
\{                     { return '{'; }
=                      { return '='; }
\+                     { return '+'; }
\-                     { return '-'; }
\*                     { return '*'; }
\/                     { return '/'; }
\n                     { lineno++; }
\"                     { BEGIN(string); yylval.text = calloc(1, 100); }
<string>\"             { BEGIN(0); return STRING; }
<string>\\n            { yylval.text[strlen(yylval.text)] = '\n'; }
<string>.              { yylval.text[strlen(yylval.text)] = yytext[0]; }
.                      { ; }
%%
int yywrap(void)
{ return 1; }
