%{
  #define YYSYNC
  extern int yylineno;
  int yylex(void);
  void yyerror(const char *,...);
  int yyparse(void);
char * typTypuName(int number);
  #include <stdio.h>
char* zmienne[100];
int zm=0;
int scopes[100] = {0};
int snum=0;
void sStart();
void sEnd();
void addVar(char *name);

int typTypu;
%}
%token <a> SBYTE BYTE SHORT USHORT  INT  UINT  LONG  ULONG
%token <a> CHAR  FLOAT DOUBLE BOOL DECIMAL
%token <a> ID
%token ID USING DOT NAMESPACE
%token CLASS CBEGIN CEND PUBLIC PRIVATE PROTECTED INTERNAL ABSTRACT SEALED
%token <a> INUM BNUM REALNUM CHARNUM 
%token STATIC VOLATILE READONLY
%type <a> DataType DataTypeSpec  AssValue IDentifier
%union{
  struct {
	  int t; // type
	  char *n; // name
  } a;
}
%%
Start : MainBody  { if(yychar == 0) puts("OK");
                 else { puts("Error - extra characters"); YYABORT; }
               }
      ;

MainBody : Body
;

Body : UsingList Lines
|  Lines
| UsingList
;

Lines : Lines Line 
| Line
;

Line : VarDecl ';'
| ClassDef 
| ClassDef ';'
| NamespaceBody
;

NamespaceBody : NAMESPACE UsingName CBEGIN {sStart();} Body CEND { sEnd(); }
;

ClassDef : ModifiersList CLASS IDentifier ImplementsList  {sStart(); addVar($3.n); } Compound  {sEnd();}
| CLASS IDentifier   ImplementsList {sStart(); addVar($2.n); }  Compound  {sEnd();}
| ModifiersList CLASS IDentifier  {sStart(); addVar($3.n); } Compound  {sEnd();}
| CLASS IDentifier  {sStart(); addVar($2.n); } Compound {sEnd();}
;

ImplementsList : ':' IDList
;

ModifiersList : VisibModifier ModifModifier
| ModifModifier
| VisibModifier
;

VisibModifier : PUBLIC
| PRIVATE
| PROTECTED
| INTERNAL
;

ModifModifier
: ABSTRACT
| SEALED
;

Compound : CBEGIN CEND
| CBEGIN  Lines CEND
;

UsingList : UsingList UsingDecl 
 | UsingDecl
 ;

UsingDecl : USING UsingName ';' ;

UsingName : UsingName DOT ID 
| ID
  ;

VarDecl : DataTypeSpec AssignList ;

DataTypeSpec : DataType { typTypu = $1.t; }
| VarModifier DataType { typTypu = $2.t; }
;

VarModifier : VisibModifier VarTypeModifier
| VisibModifier
| VarTypeModifier
;

VarTypeModifier : STATIC
| READONLY
| VOLATILE
;

AssignList : AssignList ',' Assign 
| Assign
;

Assign : IDentifier  { addVar($1.n); }
| IDentifier '=' AssValue { if (typTypu!=$3.t) 
               {
                 printf("Constant '%s' cannot be converted to type %s.", $3.n, typTypuName(typTypu));  
			exit(1);
               }
               addVar($1.n);
            }
;

AssValue :
 INUM  { $$.t=INUM; $$.n = strdup($1.n); }
| BNUM { $$.t=BNUM; $$.n = strdup($1.n); }
| REALNUM { $$.t=REALNUM; $$.n = strdup($1.n); }
| CHARNUM { $$.t=CHARNUM; $$.n = strdup($1.n); }
;

DataType : 
 SBYTE  { $$.t=INUM; }
| BYTE  { $$.t=INUM; }
| SHORT { $$.t=INUM; } 
| USHORT { $$.t=INUM; }
| INT { $$.t=INUM; }
| UINT { $$.t=INUM; }
| LONG { $$.t=INUM; }
| ULONG { $$.t=INUM; }
| CHAR { $$.t=CHARNUM; }
| FLOAT { $$.t=REALNUM; }
| DOUBLE { $$.t=REALNUM; }
| BOOL { $$.t=BNUM; }
| DECIMAL { $$.t=REALNUM; }
| ID { printf("The type %s couldnt be found", $1); exit(1); }
;

IDList : IDList ',' IDentifier
   | IDentifier
   ;

IDentifier : ID
 | '@' ID { $$.n = $2.n; }
;

%%
#pragma argsused
void yyerror(const char *fmt,...)
{
  
  printf("%s in line %d\n", fmt, yylineno);
}
int main()  { return yyparse(); }


char *typTypuName(int number)
{
switch (number) {
case INUM : return "integer";
case BNUM : return "bool";
case REALNUM : return "float";
case CHARNUM : return "char";
}
}

/*
char* zmienne[100];
int zm=0;
int scopes[100];
int snum=0;
*/

void sStart()
{
  snum++;
scopes[snum] = zm;
}

void sEnd()
{
  zm = scopes[snum];
  snum--;
}

void addVar(char *name)
{
 int i;
 for (i= scopes[snum]; i<zm; i++)
 {
   if (strcmp(zmienne[i], name)==0)
     {    printf("Identifier %s already defined\n", name); exit(1);   }
 }

 zmienne[zm] = (char*) strdup(name);
 zm++;
}

