U    \\u[0-9][0-9][0-9][0-9]
C [a-zA-Z_]
D [a-zA-Z0-9_]
E ({C}|{U})
F ({D}|{U})
M [eE][+-]?[0-9]+

%{
  int yywrap(void);
  int yylex(void);
  #include "y.tab.h"
int k=0;
%}
%x komentarz
%%
"//"[^\n]*\n { ; }
"/*" { BEGIN komentarz; k++;  }
<komentarz>"*/" { BEGIN 0; k--; } 
<komentarz>\n { ; }
<komentarz>. { ; }
sbyte { return SBYTE; }
byte { return BYTE; }
short { return SHORT; }
ushort { return USHORT; }
int { return INT; }
uint { return UINT; }
long { return LONG; }
ulong { return ULONG; }
char { return CHAR; }
float { return FLOAT; }
double { return DOUBLE; }
bool { return BOOL; }
decimal { return DECIMAL; }
using { return USING; }
namespace { return NAMESPACE; }
class { return CLASS; }
public { return PUBLIC; }
private { return PRIVATE; }
protected { return PROTECTED; }
internal { return INTERNAL; }
abstract { return ABSTRACT; }
sealed { return SEALED; }
static { return STATIC; }
readonly { return READONLY; }
volatile { return VOLATILE; }
(true|false) { yylval.a.n = strdup(yytext); return BNUM; }
[0-9]+([uU][lL]|[lL][uU]|[uU]|[lL])? { yylval.a.n = strdup(yytext); return INUM; }
0[xX][0-9a-fA-F]+([uU][lL]|[lL][uU]|[uU]|[lL])? { yylval.a.n = strdup(yytext); return INUM; }
[0-9]*\.[0-9]+{M}?[FfDdMm]? { yylval.a.n = strdup(yytext); return REALNUM; }
\'.\' { yylval.a.n = strdup(yytext); return CHARNUM; }
\'\\[\'\"\\0abfnrtv]\' { yylval.a.n = strdup(yytext); return CHARNUM; }
{U} { yylval.a.n = strdup(yytext); return CHARNUM; }
{E}{F}*   {  yylval.a.n = strdup(yytext); return ID;}
\;    { return ';'; }
\,    { return ','; }
\:   { return ':'; }
\=  { return '='; }
\{ { return CBEGIN; }
\} { return CEND; }
\@ { return '@'; }
\. { return DOT; }
" "                      { ; }
\n                       { ; }
.                        { ; }
%%
int yywrap(void) { if (k==1) 
{
printf("Error: End of file found, while '*/' expected\n"); exit(1);
}
return 1; }
