%{
/*
       Jacek Pospychala jacekp@siat.pl grupa:poniedzialki, 15:10  
*/
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
  int yylex(void);
  void yyerror(const char *,...);
  int yyparse(void);
  extern int lineno;
%}
%token NUM
%left SUM SUB
%left MUL DIV
%%
S : S E       { printf("%d\n", $2); }
  | E         { printf("%d\n", $1); }
  ;

E :
    E SUM F   { $$ = $1 + $3; }
  | F
;

F : F MUL T   { $$ = $1 * $3; }
  | T
;

T : '(' E ')' { $$ = $2; }
  | NUM
;
%%
void yyerror(const char *fmt,...) {
  if (strcmp(fmt, "parse error")==0)
    printf("Syntax error on line %d.\n", lineno);
  else {
    va_list ap;
    va_start(ap, fmt);
    vprintf(fmt, ap);
    va_end(ap);
  }
  exit(1); 
}
int main() { yyparse(); }
