%{
#include "y.tab.h"
int yywrap(void);
void dprintf(char*);
extern int lineno;
%}
%%
class { dprintf("CLASS"); return CLASS; }
int   { dprintf("INT"); return INT; }
char  { dprintf("CHAR"); return CHAR; }
[a-zA-Z_]+ { dprintf("ID"); yylval.text=(char*)strdup(yytext); return ID; }
[0-9]+ { dprintf("NUM"); yylval.inum=atoi(yytext); return NUM; }
\{    { dprintf("{"); return '{'; }
\}    { dprintf("}"); return '}'; }
\(    { dprintf("("); return '('; }
\)    { dprintf(")"); return ')'; }
\,    { dprintf(","); return ','; }
\;    { dprintf(";"); return ';'; }
\=    { dprintf("="); return '='; }
\n    { lineno++; }
.     { ; }
%%
int yywrap(void) { return 1; }
void dprintf(char*s) { ;}
