%{
int yylex(void);
void yyerror(const char *,...);
int yyparse(void);
%}
%union
{
 char *text;
 int ival;
}
%token <ival> num
%token <text> id
%type <text> S K
%type <ival> P E T F
%%
S : S K      
  | K        
  ;
K : id '(' P ')' ';' { printf("call %s\nadd sp,%d\n", $1, $3); }
  | id '(' ')' ';' { printf("call %s\n", $1); }
  ;
P : P ',' E  { printf("push %d\n", $3); $$=$1+1; } 
  | E        { printf("push %d\n", $1); $$=1; }
  ;
E : E '+' F  { $$ = $1 + $3; }
  | E '-' F  { $$ = $1 - $3; }
  | F        { $$ = $1; }
  ;
F : F '*' T  { $$ = $1 * $3; }
  | T        { $$ = $1; }
  ;
T : '(' E ')'  { $$ = $2; }
  | num       { $$ = $1; }
  ;
%%
void yyerror(const char *fmt,...) {printf("Error\n");}
int main() { return yyparse(); }
