%
% Jacek Pospychala  jacekp@siat.pl (66301)
%
function varargout = dialog_elementow(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @dialog_elementow_OpeningFcn, ...
                   'gui_OutputFcn',  @dialog_elementow_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function dialog_elementow_OpeningFcn(hObject, eventdata, handles, varargin)
handles.fig = 1;
handles.output = hObject;
guidata(hObject, handles);

function varargout = dialog_elementow_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

function sk_Callback(hObject, eventdata, handles)

function im_Callback(hObject, eventdata, handles)

function plotbtn_Callback(hObject, eventdata, handles)
figure(handles.fig);
set(0,'CurrentFigure',handles.fig);

title('Charakterystyki podstawowych elementow');
xlabel('t');
ylabel('h(t)');

legenda_odp = [];
odpowiedzi = [];
odp_pokazywac = [];
if (get(handles.odpsk, 'Value')==1) 
    odpowiedzi = [odpowiedzi ; 'sk'];
    legenda_odp = [legenda_odp; sprintf('%30s', get(handles.odpsk, 'String'))];
    if (get(handles.skrysuj, 'Value')==1) 
        odp_pokazywac = [odp_pokazywac ; 1 ]; 
    else
        odp_pokazywac = [odp_pokazywac ; 0 ]; 
    end;
end;    
if (get(handles.odpim, 'Value')==1) 
    odpowiedzi = [odpowiedzi ; 'im']; 
    legenda_odp = [legenda_odp; sprintf('%30s', get(handles.odpim, 'String'))];
    if (get(handles.imrysuj, 'Value')==1) 
        odp_pokazywac = [odp_pokazywac ; 1 ]; 
    else
        odp_pokazywac = [odp_pokazywac ; 0 ]; 
    end;
end;

legenda = [];
elementy = [];
if (get(handles.bicheck, 'Value')==1) 
    elementy = [elementy ; 'bi']; 
    legenda = [legenda; sprintf('%25s', get(handles.bicheck, 'String'))]; 
end;
if (get(handles.i1check, 'Value')==1) 
    elementy = [elementy ; 'i1']; 
    legenda = [legenda; sprintf('%25s', get(handles.i1check, 'String'))]; 
end;
if (get(handles.i2check, 'Value')==1) 
    elementy = [elementy ; 'i2']; 
    legenda = [legenda; sprintf('%25s', get(handles.i2check, 'String'))]; 
end;
if (get(handles.cicheck, 'Value')==1) 
    elementy = [elementy ; 'ci']; 
    legenda = [legenda; sprintf('%25s', get(handles.cicheck, 'String'))]; 
end;
if (get(handles.crcheck, 'Value')==1) 
    elementy = [elementy ; 'cr']; 
    legenda = [legenda; sprintf('%25s', get(handles.crcheck, 'String'))]; 
end;
if (get(handles.richeck, 'Value')==1) 
    elementy = [elementy ; 'ri']; 
    legenda = [legenda; sprintf('%25s', get(handles.richeck, 'String'))]; 
end;
if (get(handles.rrcheck, 'Value')==1) 
    elementy = [elementy ; 'rr']; 
    legenda = [legenda; sprintf('%25s', get(handles.rrcheck, 'String'))]; 
end;
if (get(handles.ocheck,  'Value')==1) 
    elementy = [elementy ; 'op']; 
    legenda = [legenda; sprintf('%25s', get(handles.ocheck, 'String'))]; 
end;

k = str2num(get(handles.kedit, 'String'));
assignin('base', 'k', k);
T = str2num(get(handles.t0edit, 'String'));
assignin('base', 'T', T);
T2 = str2num(get(handles.t1edit, 'String'));
assignin('base', 'T2', T2);
step = str2num(get(handles.step, 'String'));
assignin('base', 'step', step);
s = str2num(get(handles.steplen, 'String'));
assignin('base', 's', s);
simtime = str2num(get(handles.simtime, 'String'));
assignin('base', 'simtime', simtime);

cla;
newplot;
title('Charakterystyki podstawowych elementow');
xlabel('t');
ylabel('h(t)');

do_legendy = [];
wymuszenia = [];

dosurf=1;
if (size(k,2)>1)
    surfby='k';
    surfvals=k;
elseif (size(T,2)>1)
    surfby='T';
    surfvals=T;
elseif (size(T2,2)>1)
    surfby='T2';
    surfvals=T2;
else
    dosurf=0;
end   

if (dosurf==1) % surface plots  
    hold all;
    for i= 1:size(odpowiedzi,1) % dla kazdego wymuszenia
        wymuszenia(i) = 0;
        for j = 1:size(elementy, 1) % dla kazdego elementu
            for sstep = 1:size(surfvals,2) % dla kazdej wartosci zmienianego parametru
                assignin('base', surfby, surfvals(sstep)); % zmien wartosc parametru
                sim(['elementy\' elementy(j,:) '_' odpowiedzi(i,:) '.mdl']);
                if (odp_pokazywac(i)==1 && wymuszenia(i)==0)
                    plot(h.time(:), h.signals.values(:,1));
                    do_legendy = [do_legendy ; legenda_odp(i,:)];
                    wymuszenia(i)=1;
                end;
                plot(h.time(:), h.signals.values(:,2)); 
                do_legendy = [do_legendy ; sprintf('%30s', [ legenda(j,:) ' ' num2str(surfvals(sstep))])];
            end; 
        end;
    end;
    
else % 2D plots
    hold all;
    for i= 1:size(odpowiedzi,1)
        wymuszenia(i) = 0;
        for j = 1:size(elementy, 1)
            sim(['elementy\' elementy(j,:) '_' odpowiedzi(i,:) '.mdl']);
            if (odp_pokazywac(i)==1 && wymuszenia(i)==0)
                plot(h.time(:), h.signals.values(:,1));
                do_legendy = [do_legendy ; legenda_odp(i,:)];
                wymuszenia(i)=1;
            end;
            plot(h.time(:), h.signals.values(:,2));
            do_legendy = [do_legendy ; sprintf('%30s', legenda(j,:))];
        end;
    end;  
end; % end of 2D plots
legend(do_legendy);

function bicheck_Callback(hObject, eventdata, handles)

function i1check_Callback(hObject, eventdata, handles)

function i2check_Callback(hObject, eventdata, handles)

function cicheck_Callback(hObject, eventdata, handles)

function crcheck_Callback(hObject, eventdata, handles)

function richeck_Callback(hObject, eventdata, handles)

function rrcheck_Callback(hObject, eventdata, handles)

function ocheck_Callback(hObject, eventdata, handles)

function kedit_Callback(hObject, eventdata, handles)

function kedit_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function t0edit_Callback(hObject, eventdata, handles)

function t0edit_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function t1edit_Callback(hObject, eventdata, handles)

function t1edit_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function step_Callback(hObject, eventdata, handles)

function step_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function skrysuj_Callback(hObject, eventdata, handles)

function imrysuj_Callback(hObject, eventdata, handles)

function steplen_Callback(hObject, eventdata, handles)

function steplen_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function simtime_Callback(hObject, eventdata, handles)

function simtime_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbutton10_Callback(hObject, eventdata, handles)
figure(handles.fig);
set(0,'CurrentFigure',handles.fig);

legenda_odp = [];
odpowiedzi = [];
odp_pokazywac = [];
if (get(handles.odpsk, 'Value')==1) 
    odpowiedzi = [odpowiedzi ; 'sk'];
    legenda_odp = [legenda_odp; sprintf('%30s', get(handles.odpsk, 'String'))];
    if (get(handles.skrysuj, 'Value')==1) 
        odp_pokazywac = [odp_pokazywac ; 1 ]; 
    else
        odp_pokazywac = [odp_pokazywac ; 0 ]; 
    end;
end;    
if (get(handles.odpim, 'Value')==1) 
    odpowiedzi = [odpowiedzi ; 'im']; 
    legenda_odp = [legenda_odp; sprintf('%30s', get(handles.odpim, 'String'))];
    if (get(handles.imrysuj, 'Value')==1) 
        odp_pokazywac = [odp_pokazywac ; 1 ]; 
    else
        odp_pokazywac = [odp_pokazywac ; 0 ]; 
    end;
end;

legenda = [];
elementy = [];
if (get(handles.bicheck, 'Value')==1) 
    h = '[[0 0 k]; [0 0  1]]';
    elementy = [elementy ; h]; 
    legenda = [legenda; sprintf('%25s', get(handles.bicheck, 'String'))]; 
end;
if (get(handles.i1check, 'Value')==1) 
    h = '[[0 0 k]; [0 T  1]]';
    elementy = [elementy ; h]; 
    legenda = [legenda; sprintf('%25s', get(handles.i1check, 'String'))]; 
end;
if (get(handles.i2check, 'Value')==1) 
    h = '[[0 0 k]; [T T2 1]]';
    elementy = [elementy ; h]; 
    legenda = [legenda; sprintf('%25s', get(handles.i2check, 'String'))]; 
end;
if (get(handles.cicheck, 'Value')==1) 
    h = '[[0 0 k]; [0 1  0]]';
    elementy = [elementy ; h]; 
    legenda = [legenda; sprintf('%25s', get(handles.cicheck, 'String'))]; 
end;
if (get(handles.crcheck, 'Value')==1) 
    h = '[[0 0 k]; [T 1  0]]';
    elementy = [elementy ; h]; 
    legenda = [legenda; sprintf('%25s', get(handles.crcheck, 'String'))]; 
end;
if (get(handles.richeck, 'Value')==1) 
    h = '[[0 k 0]; [0 0  1]]';
    elementy = [elementy ; h]; 
    legenda = [legenda; sprintf('%25s', get(handles.richeck, 'String'))]; 
end;
if (get(handles.rrcheck, 'Value')==1) 
    h = '[[0 k 0]; [0 T  1]]';
    elementy = [elementy ; h]; 
    legenda = [legenda; sprintf('%25s', get(handles.rrcheck, 'String'))]; 
end;
%if (get(handles.ocheck,  'Value')==1) 
%    h =
%    elementy = [elementy ; h];  
%    legenda = [legenda; sprintf('%25s', get(handles.ocheck, 'String'))]; 
%end;

cla;

do_legendy = [];
wymuszenia = [];

k = str2num(get(handles.kedit, 'String'));
assignin('base', 'k', k);
T = str2num(get(handles.t0edit, 'String'));
assignin('base', 'T', T);
T2 = str2num(get(handles.t1edit, 'String'));
assignin('base', 'T2', T2);
step = str2num(get(handles.step, 'String'));
assignin('base', 'step', step);
s = str2num(get(handles.steplen, 'String'));
assignin('base', 's', s);
simtime = str2num(get(handles.simtime, 'String'));
assignin('base', 'simtime', simtime);

dosurf=1;
if (size(k,2)>1)
    surfby='k';
    surfvals=k;
elseif (size(T,2)>1)
    surfby='T';
    surfvals=T;
elseif (size(T2,2)>1)
    surfby='T2';
    surfvals=T2;
else
    dosurf=0;
end   

if (dosurf==1) % surface plots  
    hold all
    for j = 1:size(elementy,1) % dla kazdego elementu
        for sstep = 1:size(surfvals,2) % dla kazdej wartosci zmienianego parametru
            eval([surfby ' = ' num2str(surfvals(sstep)) ';']);
            eval(['h = ' elementy(j,:) ';']);
            sys = tf(h(1,:), h(2,:));
            if (get(handles.bode, 'Value')==1)
                bode(sys);
            else
                nyquist(sys);
            end;
            do_legendy = [do_legendy ; sprintf('%30s', [ legenda(j,:) ' ' num2str(surfvals(sstep))])];
        end; 
    end;
    
else % 2D plots
    hold all;
    for j = 1:size(elementy,1)
        eval(['h = ' elementy(j,:) ';']);
        sys = tf(h(1,:), h(2,:));
        if (get(handles.bode, 'Value')==1)
            bode(sys);
        else
            nyquist(sys);
        end;
        do_legendy = [do_legendy ; sprintf('%30s', legenda(j,:))];
    end;
end; % end of 2D plots
legend(do_legendy);
